package com.eis.hw;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;

/**
 * Eine Defaultimplementierung für den ConnectionManager
 * ist für nicht-containergemanagede Umgebungen erforderlich.
 * 
 * Hier wird keine funktionierende Implementierung gezeigt, der
 * Adapter ist damit formal nicht konform zur Spezifikation.  
 */
public class DefaultConnectionManager implements ConnectionManager {

	/**
	 * Die UID der Klasse. 
	 */
	private static final long serialVersionUID = 1589810599645876875L;

	public Object allocateConnection(
			final ManagedConnectionFactory mcf,	final ConnectionRequestInfo cri) 
	throws ResourceException {
		
		/*
		 * Einfachste Implementierung für stand alone Anwendungen.   
		 * 
		 * - Beschaffung und Pooling von ManagedConnectionImpl Instanzen aus Sicht
		 *   einer JVM Instanz
		 * - Verwaltung des Pool unter Nutzung von 
		 *   ManagedConnectionFactory.matchManagedConnections
		 * - Erzeugung von Connection Handles mit ManagedConnectionImpl
		 */
		ManagedConnection mc = mcf.createManagedConnection(null, cri);
		return mc.getConnection(null, cri);
	}
}