package com.eis.hw;

import javax.resource.ResourceException;

/**
 * Das Client-Interface des Connection Handles.
 * 
 * Zwingend erforderlich ist nur eine close Merthode (die auch
 * Fehler werfen darf). Die Businessmethoden müssen nicht 1:1
 * auf diejenigen des EIS passen, die Implementierung delegiert
 * ohnehin an die ManagedConnectionImpl.
 */
public interface HelloWorldConnection {

	/**
	 * Eine close Methode muss laut Spec angeboten werden.
	 * 
	 * Sie darf auch Exceptions werfen. 
	 */
	void close();

	/**
	 * Das hier ist eine Adaptermethode, hier im Beispiel soll
	 * einfach nur "Hello" ausgegeben werden.
	 * 
	 * @exception ResourceException
	 * @return Ergebnis des Aufrufs
	 */
	String helloWorldCall() throws ResourceException;

}