package com.eis.hw;

import javax.resource.ResourceException;

/**
 * Das Client-Interface der Connection Handle Factory.
 */
public interface HelloWorldConnectionFactory {

	/**
	 * Forderungen aus der Spec:
	 * 
	 * @return ein Connection Handle
	 * @throws ResourceException
	 */
	HelloWorldConnection getConnection() throws ResourceException;

	/**
	 * Gibt ein Connection Handle mit der Übergabe von clientspezifischen
	 * Requestparametern in Form von ConnectionRequestInfo
	 * 
	 * @param cri
	 *            Clientparameter
	 * @return ein Connection Handle
	 * @throws ResourceException
	 */
	HelloWorldConnection getConnection(final HelloWorldConnectionRequestInfo cri)
			throws ResourceException;

}