package com.eis.hw;

import javax.resource.spi.ConnectionRequestInfo;

/**
 * Value Object für die Übergabe von clientspezifischen Informationen
 * beim Aufruf von getConnection.
 * 
 * Forderungen der Spec:
 * 
 * Nach 16.4 und 6.5.1.2 der Spec ist eine Implementierung für hashCode
 * und equals auf der Basis der Klasseneigenschaften zu liefern.
 * Container organisieren u.a. auf dieser Grundlage Connection Pooling.
 */
public final class HelloWorldConnectionRequestInfo 
implements ConnectionRequestInfo {

	private String message = null;

	public String getMessage() {
		return message;
	}

	public void setMessage(String user) {
		this.message = user;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((message == null) ? 0 : message.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final HelloWorldConnectionRequestInfo other = (HelloWorldConnectionRequestInfo) obj;
		if (message == null) {
			if (other.message != null) return false;
		} else if (!message.equals(other.message)) return false;
		return true;
	}
	
	@Override
	public String toString() {
		return this.message;
	}
}