package com.eis.hw;

import javax.resource.ResourceException;
import javax.resource.spi.ManagedConnectionMetaData;

public final class ManagedConnectionMetaDataImpl implements ManagedConnectionMetaData {

	private final ManagedConnectionImpl managedConnection;
	
	ManagedConnectionMetaDataImpl(ManagedConnectionImpl managedConnection) {
		this.managedConnection = managedConnection;
	}

	/**
	 * Der Name des EIS.
	 */
	public String getEISProductName() throws ResourceException {
		return "Ein Hello World Adapter";
	}

	/**
	 * Die Version des EIS.
	 */
	public String getEISProductVersion() throws ResourceException {
		return "0.1";
	}

	/**
	 * Die maximale Anzahl der physikalischen Connections des EIS
	 * in der durch ManagedConnection und ManagedConnectionFactory
	 * festgelegten Konfiguration.
	 * 
	 * 0 bedeutet es gibt kein Limit oder es ist keines bekannt.
	 */
	public int getMaxConnections() throws ResourceException {
		// Code der mit den Eigenschaften von managedConnection 
		// die Poolsize ermittelt
		return 0;
	}

	/**
	 * Der dem EIS bekannte Username der aktiven Verbindung.
	 */ 
	public String getUserName() throws ResourceException {
		return this.managedConnection.getUserName();
	}
}