package com.ora.client;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.resource.ResourceException;
import javax.rmi.PortableRemoteObject;
import javax.transaction.UserTransaction;

import com.eis.hw.HelloWorldConnection;
import com.eis.hw.HelloWorldConnectionFactory;
import com.eis.hw.HelloWorldConnectionRequestInfo;

public class Client {

	/**
	 * Dieser Test funktioniert, man muss sich aber klar machen, dass sämtlicher
	 * Code im Kontext des Clients ausgeführt wird.
	 * 
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			/**
			 * Instead of requiring the developer to hard-code specific JNDI
			 * bootstrapping properties, we have put a jndi.properties file
			 * within appserv-rt.jar.
			 * 
			 * Include both $GLASSFISH_HOME/lib/appserv-rt.jar and
			 * $APS_HOME/lib/javaee.jar in the client's classpath!
			 */
			InitialContext ctxt = new InitialContext();

			System.out.println(ctxt.getNameInNamespace());

			HelloWorldConnectionFactory factory = (HelloWorldConnectionFactory) 
			PortableRemoteObject.narrow(ctxt.lookup("eis/helloworld"), HelloWorldConnectionFactory.class);
			
			UserTransaction userTransaction = (UserTransaction) 
			PortableRemoteObject.narrow(ctxt.lookup("UserTransaction"), UserTransaction.class);

			{
				try {
					userTransaction.begin();
					HelloWorldConnection connection = factory.getConnection();
					System.out.println(connection.helloWorldCall());
					connection.close();
					try {
						userTransaction.commit();
					} catch (Exception e) {
						e.printStackTrace();
					} 
				} catch (Exception e) {
					try {
						userTransaction.rollback();
					} catch (Exception e1) {
						e1.printStackTrace();
					} 
					e.printStackTrace();
				} 
			}
			{
				HelloWorldConnection connection = factory.getConnection();
				System.out.println(connection.helloWorldCall());
				// connection.close();
			}
			{
				HelloWorldConnection connection = factory.getConnection();
				System.out.println(connection.helloWorldCall());
				// connection.close();
			}
			{
				// hier mit Parametern
				HelloWorldConnectionRequestInfo info = new HelloWorldConnectionRequestInfo();
				info.setMessage("duke");
				HelloWorldConnection connection = factory.getConnection(info);
				System.out.println(connection.helloWorldCall());
				connection.close();
			}
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (ResourceException e) {
			e.printStackTrace();
		}
		synchronized (Client.class) {
			try {
				Client.class.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
	}
}